<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>HW Advanced JS #3 - Destructors</title>
    <link rel="stylesheet" href="css/reset.css">
    <link rel="stylesheet" href="css/style.css">
</head>
<body>
    <div class="container">
        <h1 class="page-title">HW Advanced JS #3 - Homework3-destructuring</h1>
        <div class="task-block">
            <p class="question"><span class="quoted">Вопрос:</span>Обьясните своими словами, как вы понимаете, что такое деструктуризация и зачем она нужна</p>
            <div class="answer-wrapper">
                <p class="answer">
                    Реально, и почему же я не додумывался до этого раньше?! Вывод пятиэтажных селекторов да еще и в цикле - еще то удовольствие! Каюсь, когда не знал про деструкторы, творил такое на JS, да и еще на простых ковычках.
                    А так, просто присвоил ныжным параметрам переменные и делай что хочешь!
                </p>
            </div>
        </div>
        <div class="task-block">
            <p class="question"><span class="quoted">Задача 1:</span>Две компании решили объединиться, и для этого им нужно объединить базу данных своих клиентов.</p>
            <ul class="reqular">
               <li>
                    У вас есть 2 массива строк, в каждом из них - фамилии клиентов. Создайте на их основе один массив, который будет представлять собой объединение двух массив без повторяющихся фамилий клиентов.
               </li>
            </ul> 

            <p class="question"><span class="quoted">Задача 2:</span>Перед вами массив characters, состоящий из объектов. Каждый объект описывает одного персонажа.</p>
            <ul class="reqular">
               <li>
                    У вас есть 2 массива строк, в каждом из них - фамилии клиентов. Создайте на их основе один массив, который будет представлять собой объединение двух массив без повторяющихся фамилий клиентов.
               </li>
               <li>
                    Создайте на его основе массив charactersShortInfo, состоящий из объектов, в которых есть только 3 поля - name, lastName и age.
               </li>
            </ul> 

            <p class="question"><span class="quoted">Задача 3:</span>У нас есть объект user. Напишите деструктурирующее присваивание, которое</p>
            <ul class="reqular">
                <li>
                    свойство name присвоит в переменную name
                </li>
                <li>
                    свойство years присвоит в переменную age
                </li>
                <li>
                    свойство isAdmin присвоит в переменную isAdmin (false, если нет такого свойства)
                </li>
            </ul> 

            <p class="question"><span class="quoted">Задача 4:</span>Детективное агентство несколько лет собирает информацию о возможной личности Сатоши Накамото. Вся информация, собранная в конкретном году, хранится в отдельном объекте. Всего таких объектов три - satoshi2018, satoshi2019, satoshi2020</p>
            <ul class="reqular">
                <li>
                    Чтобы составить полную картину и профиль, вам необходимо объединить данные из этих трех объектов в один объект - fullProfile
                </li>
                <li>
                    Учтите, что некоторые поля в объектах могут повторяться. В таком случае в результирующем объекте должно сохраниться значение, которое было получено позже (например, значение из 2020 более приоритетное по сравнению с 2019)
                </li>
                <li>
                    Напишите код, который составит полное досье о возможной личности Сатоши Накамото. Изменять объекты satoshi2018, satoshi2019, satoshi2020 нельзя.
                </li>
            </ul> 

            <p class="question"><span class="quoted">Задача 5:</span>Дан массив книг. Вам нужно добавить в него еще одну книгу, не изменяя существующий массив (в результате операции должен быть создан новый массив).</p>
            <ul class="reqular"></ul>

            <p class="question"><span class="quoted">Задача 6:</span>Дан обьект employee. Добавьте в него свойства age и salary, не изменяя изначальный объект (должен быть создан новый объект, который будет включать все необходимые свойства). Выведите новосозданный объект в консоль.</p>
            <ul class="reqular"></ul>

            <p class="question"><span class="quoted">Задача 7:</span>Дополните код так, чтоб он был рабочим</p>
            <ul class="reqular">
                <li>
                    <pre>
                        <code>
                            const array = ['value', () => 'showValue'];
                        </code>
                        <code>
                            alert(value); // должно быть выведено 'value'
                            alert(showValue());  // должно быть выведено 'showValue'                        
                        </code>
                    </pre>
                    
                </li>
            </ul>



            <pre class="result">
                <div id="root"></div>
            </pre>
            
        </div>
    </div>
    

    <script src="js/task1.js"></script>
    <script src="js/task2.js"></script>
    <script src="js/task3.js"></script>
    <script src="js/task4.js"></script>
    <script src="js/task5.js"></script>
    <script src="js/task6.js"></script>
    <script src="js/task7.js"></script>
</body>
</html>